/*
 * 
 * 
 * Copyright (C) 2006 SIPfoundry Inc.
 * Licensed by SIPfoundry under the LGPL license.
 * 
 * Copyright (C) 2006 Pingtel Corp.
 * Licensed to SIPfoundry under a Contributor Agreement.
 * 
 * $
 */
package org.sipfoundry.sipxconfig.site.dialplan;

import org.apache.commons.lang.enums.Enum;
import org.apache.tapestry.BaseComponent;
import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.form.IPropertySelectionModel;
import org.sipfoundry.sipxconfig.admin.dialplan.AutoAttendant;
import org.sipfoundry.sipxconfig.admin.dialplan.DialPlanContext;
import org.sipfoundry.sipxconfig.components.LocalizedOptionModelDecorator;

public abstract class SpecialAttendantPanel extends BaseComponent {
    public abstract DialPlanContext getDialPlanContext();

    public abstract AutoAttendant getAutoAttendant();

    public abstract Mode getMode();

    public abstract void setMode(Mode mode);

    public void onApply() {
        boolean enable = Mode.SPECIAL.equals(getMode());
        getDialPlanContext().specialAutoAttendantMode(enable, getAutoAttendant());
    }

    public IPropertySelectionModel getModeModel() {
        LocalizedOptionModelDecorator model = new LocalizedOptionModelDecorator();
        model.setModel((IPropertySelectionModel) getBeans().getBean("modeModel"));
        model.setMessages(getMessages());
        model.setResourcePrefix("mode.");
        return model;
    }

    protected void renderComponent(IMarkupWriter writer, IRequestCycle cycle) {
        // use standard mode by default
        if (getMode() == null) {
            setMode(Mode.NORMAL);
        }
        super.renderComponent(writer, cycle);
    }

    public static final class Mode extends Enum {
        public static final Mode NORMAL = new Mode("normal");
        public static final Mode SPECIAL = new Mode("special");

        private Mode(String name) {
            super(name);
        }
    }
}
